/*
 * hfcl_timer_recovery.h
 * Copyright (C) 2007, 2012, Hitachi, Ltd.
 * Author(s): Yoshihiro Toyohara <yoshihiro.toyohara.qs@hitachi.com>
 */
/*
 * $Id: hfcl_timer_recovery.h,v 1.8.2.6.2.4.4.4 2012/07/04 10:17:52 toyo Exp $
 */


extern void hfc_hwerr_int(struct adap_info *ap,
					uint int_a_reg,
					uint status_reg0,
					uint status_reg1,
					uint detail_reg);

extern void hfc_errlog( struct adap_info *ap,
				struct target_info	*target,
				struct hfc_pkt		*hfcp,
				uchar				type,
				uint				err_id,
				uint				err_num,
				uchar				*data,
				ushort				data_len );

extern void hfc_abend(
	struct adap_info        *ap,
	uchar                   type);

extern void hfc_logout(                                                /* FCWIN-0220 */
	struct adap_info        *ap,
	uint                    errno,
	uchar                   mode);

extern void hfc_fpp_logout( struct adap_info *ap, uint errno, uchar mode );

extern void hfc_five_logout( struct adap_info *ap, uint errno, uchar mode );

extern int hfc_pcibus_chk(struct adap_info *ap);

extern void hfc_mck_recovery_fpp(struct adap_info *ap,uchar type);

extern void hfc_mck_recovery_five(struct adap_info *ap,uchar type);

extern int hfc_mck_port_recovery(struct adap_info	*ap);

extern void hfc_chk_stop(struct adap_info *ap, uchar lock);		/* FCLNX-0279 */

extern void hfc_watchdog(struct wtimer *w_timer);

extern void hfc_reset_start(struct adap_info *,uchar); 

extern void hfc_reset_adap_info(struct adap_info *);

extern int hfc_toutchk_xob(
	struct adap_info	*ap,
	struct target_info	*target,
	struct hfc_pkt		*hfcp,    
	uchar				lun,
	uchar				mode);

extern void hfc_hand2_trace(
	uchar               id,
	uchar               sub_id,
	struct adap_info    *ap,
	struct target_info  *target,
	struct hfc_pkt		*hfcp,
	uint64_t            etc1,
	uint64_t            etc2,
	uint64_t            etc3);

extern void hfc_reset_watchdog(struct adap_info *ap);

extern int hfc_issue_forced_mck(struct adap_info *ap, uchar type);

extern int hfc_sfp_port_recovery(struct adap_info *ap, int immdt_cmd);		/* FCLNX-0514*/
extern void hfc_occurred_mck(struct adap_info *ap, uchar point);			/* FCLNX-0535 */

extern int hfc_force_linkdown( struct adap_info *ap , uchar proc, uchar skip);		/* FCLNX_GPL-105 */
extern int hfc_force_linkdown_recovery(struct adap_info *ap);						/* FCLNX_GPL-105 */
extern int hfc_force_linkdown_recovery_port(struct adap_info *ap, int immdt_cmd);	/* FCLNX_GPL-105 */

extern void hfc_clear_errinfo_i( struct adap_info *ap );	/* FCLNX_GPL-394 */
extern int hfc_get_isolparam_i( struct adap_info *ap, struct hfc_isol_info *isolinfo );	/* FCLNX_GPL-394 */
extern void hfc_check_errcount(struct adap_info *ap);	/* FCLNX_GPL-394 */
extern void hfc_watched_errcount_i(struct adap_info *ap, struct target_info *target, uchar err_flag);/* FCLNX_GPL-394 */
