/*
 * hfclddioc.h
 * Copyright (C) 2007, 2012, Hitachi, Ltd.
 * Author(s): Yoshihiro Toyohara <yoshihiro.toyohara.qs@hitachi.com>
 */
/*
 * $Id: hfclddioc.h,v 1.6.2.15.2.6.2.1.2.8 2012/07/04 10:17:52 toyo Exp $
 */


#ifndef _H_HFCDDIOC             /* Double definition prevention */
#define _H_HFCDDIOC

/**************************************************************************************************/
/* data structure                                                                                 */
/**************************************************************************************************/
typedef unsigned char       uchar;
#ifdef __WIN
typedef unsigned short      ushort;
typedef unsigned int        uint;
typedef unsigned long       ulong;
typedef unsigned __int64    uint64_t ;  /* @0007 */
typedef __int64             int64_t ;   /* @0007 */
#else
#ifndef __KERNEL__
#ifdef __LINUX
#include <stdint.h>
#else  /*__LINUX*/
typedef unsigned long long    uint64_t ;
#endif /*__LINUX*/
#endif
/*typedef long long         int64_t ;     */
#endif

/******************************************************/
/* Linux x86-64 <-> Linux32                2005.02.23 */
/******************************************************/
#if defined(__LINUX) && defined(__GNUC__) && defined(__x86_64)
#define HFC_VAL_ATTR    __attribute__((packed))
#define HFC_VAL_ATTR_C  __attribute__((aligned(1)))
#else   /*__LINUX && __GNUC__ && __x86_64*/
#define HFC_VAL_ATTR_C
#define HFC_VAL_ATTR
#endif  /*__LINUX && __GNUC__ && __x86_64*/

/************************************************************************/
/*   ioctl                                                              */
/************************************************************************/
/* SIGNATURE */
#define IOCTL_SIGNATURE     "HFCDRV"

/************************************************************/
/*   command code (for drivers)                            */
/************************************************************/
#ifdef __WIN
#define HFC_FNC_SC_INQU                     0x0900
#define HFC_FNC_SC_CMD                      0x0904
#define HFC_FNC_SC_NMSRV                    0x0905
#define HFC_FNC_SC_GWWN                     0x0906
#define HFC_FNC_SC_PAYLD                    0x0907
#define HFC_FNC_SC_GRNID                    0x0908
#define HFC_FNC_SC_SRNID                    0x0909
#define HFC_FNC_SC_APSTAT                   0x090A
#define HFC_FNC_SC_API                      0x0940
#define HFC_FNC_SC_SPT                      0x0941
#define HFC_FNC_DIAG0                       0x09FF
#endif
#ifdef __LINUX
#define HFC_IOC_MAGIC   'F'

#define HFC_FNC_SC_INQU     _IOWR(HFC_IOC_MAGIC,0,struct hfc_ioctl_inquiry)
#define HFC_FNC_SC_CMD      _IOWR(HFC_IOC_MAGIC,1,struct hfc_ioctl_cdb)
#define HFC_FNC_SC_NMSRV    _IOWR(HFC_IOC_MAGIC,2,struct hfc_ioctl_gidft)
#define HFC_FNC_SC_GWWN     _IOWR(HFC_IOC_MAGIC,3,struct hfc_ioctl_gidpn)
#define HFC_FNC_SC_PAYLD    _IOWR(HFC_IOC_MAGIC,4,struct hfc_ioctl_payload)
#define HFC_FNC_SC_GRNID    _IOWR(HFC_IOC_MAGIC,5,struct hfc_ioctl_rnid)
#define HFC_FNC_SC_SRNID    _IOWR(HFC_IOC_MAGIC,6,struct hfc_ioctl_rnid)
#define HFC_FNC_SC_APSTAT   _IOWR(HFC_IOC_MAGIC,7,struct hfc_ioctl_adap_stat)
#define HFC_FNC_SC_API      _IOWR(HFC_IOC_MAGIC,8,struct hfc_ioctl_api)
#define HFC_FNC_DIAG0       _IOWR(HFC_IOC_MAGIC,9,struct diag_ioctl)
#define HFC_FNC_SC_SPT      _IOWR(HFC_IOC_MAGIC,10,struct hfc_ioctl_spt)
#define HFC_FNC_SC_TGTMAP   _IOWR(HFC_IOC_MAGIC,11,struct hfc_ioctl_tgt_map)        // 2005.01.19
#define HFC_FNC_SC_PBIND    _IOWR(HFC_IOC_MAGIC,12,struct hfc_ioctl_fcp_binding)    // 2005.01.19
#define HFC_FNC_SC_PRINFO   _IOWR(HFC_IOC_MAGIC,13,struct hfc_ioctl_proc_info)      // 2005.01.28
#define HFC_FNC_SC_GSID     _IOWR(HFC_IOC_MAGIC,14,struct hfc_ioctl_gpnid)
#define HFC_FNC_SC_FC4STAT  _IOWR(HFC_IOC_MAGIC,15,struct hfc_ioctl_fc4stat)        // FCLNX-0404
//#define HFC_FNC_MP_RDPARM	_IOWR(HFC_IOC_MAGIC,16,struct hfc_mp_parameters)		*** Attention!! : defined hfcddioc2.h ***
//#define HFC_FNC_MP_WRPARM	_IOWR(HFC_IOC_MAGIC,17,struct hfc_mp_parameters)		*** Attention!! : defined hfcddioc2.h ***
#define HFC_FNC_MP_TGTMAP	_IOWR(HFC_IOC_MAGIC,18,struct hfc_mp_target)
//#define HFC_FNC_MP_LUMAP	_IOWR(HFC_IOC_MAGIC,19,struct hfc_mp_lu)				*** Attention!! : defined hfcddioc2.h ***
//#define HFC_FNC_WWN_INFO	_IOWR(HFC_IOC_MAGIC,20,struct hfc_ioctl_wwn)			*** Attention!! : defined hfcddwwn.h ***
//#define HFC_FNC_MP_PTHEALTH	_IOWR(HFC_IOC_MAGIC,21,struct hfc_mp_path_health)	*** Attention!! : defined hfcddioc2.h ***
//#define HFC_FNC_MP_LGTGTMAP	_IOWR(HFC_IOC_MAGIC,22,struct hfc_mp_lgtarget)		*** Attention!! : defined hfcddioc2.h ***
//#define HFC_FNC_MP_LGPATH1	_IOWR(HFC_IOC_MAGIC,23,struct hfc_mp_lgpath_info1)	*** Attention!! : defined hfcddioc2.h ***
//#define HFC_FNC_MP_SETPATH	_IOWR(HFC_IOC_MAGIC,24,struct hfc_mp_set_path)		*** Attention!! : defined hfcddioc2.h ***
#define HFC_FNC_ADP_ENABLE  _IOWR(HFC_IOC_MAGIC,28,struct hfc_ioctl_adp_enable)		// hotplug
#define HFC_FNC_ADP_DISABLE _IOWR(HFC_IOC_MAGIC,29,struct hfc_ioctl_adp_enable)		// hotplug
#define HFC_FNC_SCSI_SCAN   _IOWR(HFC_IOC_MAGIC,30,struct hfc_ioctl_adp_enable)		// FCLNX-0303
//#define HFC_FNC_ADP_PATHCHG _IOWR(HFC_IOC_MAGIC,31,struct hfc_ioctl_adp_enable)	*** Attention!! : defined hfcddioc2.h ***
#define HFC_FNC_HBA_ISOLATION  _IOWR(HFC_IOC_MAGIC,32,struct hfc_isol_info)			/* FCLNX-0454 */
#define HFC_FNC_READ_APPARAM   _IOWR(HFC_IOC_MAGIC,33,struct hfc_ioctl_read_apparam)	/* FCLNX-0454 */
//#define HFC_FNC_MP_LGDEV_PARM _IOWR(HFC_IOC_MAGIC,34,struct hfc_mp_lg_dev_parameters)		/* FCLNX-0677 */
#endif

/************************************************************/
/*   command code (for tools)                               */
/************************************************************/
#ifdef __WIN
#define IOCTL_HFC_SC_INQU       CTL_CODE( 0x9090, HFC_FNC_SC_INQU,       METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_CMD        CTL_CODE( 0x9090, HFC_FNC_SC_CMD,        METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_NMSRV      CTL_CODE( 0x9090, HFC_FNC_SC_NMSRV,      METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_GWWN       CTL_CODE( 0x9090, HFC_FNC_SC_GWWN,       METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_PAYLD      CTL_CODE( 0x9090, HFC_FNC_SC_PAYLD,      METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_GRNID      CTL_CODE( 0x9090, HFC_FNC_SC_GRNID,      METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_SRNID      CTL_CODE( 0x9090, HFC_FNC_SC_SRNID,      METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_APSTAT     CTL_CODE( 0x9090, HFC_FNC_SC_APSTAT,     METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_API        CTL_CODE( 0x9090, HFC_FNC_SC_API,        METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_SC_SPT        CTL_CODE( 0x9090, HFC_FNC_SC_SPT,        METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#define IOCTL_HFC_DIAG0         CTL_CODE( 0x9090, HFC_FNC_DIAG0,         METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA )
#else
#define IOCTL_HFC_SC_INQU       HFC_FNC_SC_INQU
#define IOCTL_HFC_SC_CMD        HFC_FNC_SC_CMD
#define IOCTL_HFC_SC_NMSRV      HFC_FNC_SC_NMSRV
#define IOCTL_HFC_SC_GWWN       HFC_FNC_SC_GWWN
#define IOCTL_HFC_SC_GSID       HFC_FNC_SC_GSID
#define IOCTL_HFC_SC_PAYLD      HFC_FNC_SC_PAYLD
#define IOCTL_HFC_SC_GRNID      HFC_FNC_SC_GRNID
#define IOCTL_HFC_SC_SRNID      HFC_FNC_SC_SRNID
#define IOCTL_HFC_SC_APSTAT     HFC_FNC_SC_APSTAT
#define IOCTL_HFC_SC_API        HFC_FNC_SC_API
#define IOCTL_HFC_SC_SPT        HFC_FNC_SC_SPT
#define IOCTL_HFC_SC_TGTMAP     HFC_FNC_SC_TGTMAP       // 2005.01.19
#define IOCTL_HFC_SC_PBIND      HFC_FNC_SC_PBIND        // 2005.01.19
#define IOCTL_HFC_SC_PRINFO     HFC_FNC_SC_PRINFO       // 2005.01.28
#define IOCTL_HFC_SC_FC4STAT    HFC_FNC_SC_FC4STAT      // FCLNX-0404
#define IOCTL_HFC_MP_RDPARM		HFC_FNC_MP_RDPARM
#define IOCTL_HFC_MP_WRPARM		HFC_FNC_MP_WRPARM
#define IOCTL_HFC_MP_TGTMAP		HFC_FNC_MP_TGTMAP
#define IOCTL_HFC_MP_LUMAP		HFC_FNC_MP_LUMAP
#define IOCTL_HFC_MP_SETPATH	HFC_FNC_MP_SETPATH
#define IOCTL_HFC_MP_PTHEALTH	HFC_FNC_MP_PTHEALTH
#define IOCTL_HFC_MP_LGTGTMAP	HFC_FNC_MP_LGTGTMAP
#define IOCTL_HFC_MP_LGPATH1	HFC_FNC_MP_LGPATH1
#define IOCTL_HFC_SC_APENABLE	HFC_FNC_ADP_ENABLE		// hotplug
#define IOCTL_HFC_SC_APDISABLE	HFC_FNC_ADP_DISABLE		// hotplug
#define IOCTL_HFC_SC_SCSISCAN	HFC_FNC_SCSI_SCAN		// FCLNX-0303
#define IOCTL_HFC_ADP_PATHCHG	HFC_FNC_ADP_PATHCHG
#define IOCTL_HFC_DIAG0         HFC_FNC_DIAG0
#define IOCTL_HFC_HBA_ISOLATION HFC_FNC_HBA_ISOLATION	/* FCLNX-0454 */
#define IOCTL_HFC_READ_APPARAM	HFC_FNC_READ_APPARAM	/* FCLNX-0454 */
#define IOCTL_HFC_MP_LG_DEV_PARM	HFC_FNC_MP_LGDEV_PARM	/* FCLNX-0677 */

// #define #define IOCTL_HFC_WWN_INFO	HFC_FNC_WWN_INFO    *** Attention!! : defined hfcddwwn.h ***
#endif

/************************************************************************/
/* include File                                                         */
/************************************************************************/
#ifdef _HFC_PCM
#include "hfclddioc2.h"
#endif

/************************************************************************/
/*   DIAG                                                               */
/************************************************************************/
struct trc_seg_info {
    uchar               seg_no ;
    uchar               resv0 ;
    uchar               mode ;
    uchar               ctl ;
    uint                top_port_id ;
    uint                bottom_port_id ;
    uint                resv1 ;
};

struct fw_trc_info {
    uchar               trc_num ;
    uchar               inst ;
    uchar               resv0[14] ;
    struct trc_seg_info trc_seg[4] ;
    uchar               resv1[48] ;
};

/*-------------------------*/
/*--- HFCDIAG0 struct  ----*/
/*-------------------------*/
struct diag_ioctl {
    uchar    sub_cmd                HFC_VAL_ATTR_C;
#define HFC_DG_SETFW        0x01
#define HFC_DG_MIHLOG       0x02
#define HFC_DG_LDCHTRC      0x03
#define HFC_DG_SMINT        0x04
#define HFC_DG_FORCSLOG     0x05
#define HFC_DG_FWSTART      0x09
#define HFC_DG_FWPOST       0x0a
#define HFC_DGRD_INITTBL    0x10
#define HFC_DGRD_XOB        0x11
#define HFC_DGRD_XRB        0x12
#define HFC_DGRD_SEGINFO    0x13
#define HFC_DGRD_SCMD       0x14
#define HFC_DGRD_ADAP       0x15
#define HFC_DGRD_TARGET     0x16
#define HFC_DGRD_DEV        0x17
#define HFC_DGRD_HFCINFO    0x18
#define HFC_DGRD_DDTRC      0x19
#define HFC_DGRD_MB         0x1a
#define HFC_DGRD_VER        0x1b
#define HFC_DGRD_HWLOG      0x1c
#define HFC_DGRD_TREE       0x1d
#define HFC_DG_RDPCI        0x20
#define HFC_DG_WRPCI        0x21
#define HFC_DG_RDPCI_CFG    0x22
#define HFC_DG_WRPCI_CFG    0x23
#define HFC_DG_FSTOP        0x24 /* @1.86 */
#define HFC_DGRD_MPINFO     0x25
#define HFC_DG_INITMDST     0x26
#define HFC_DG_FCPMDST      0x27
#define HFC_DGRD_MNGINFO    0x28
#define HFC_DGRD_PKGTYPE    0x29
#define HFC_DGRD_WWN        0x2a
#define HFC_DGRD_UID        0x2b    /* FCWIN-XXXX */
#define HFC_DGRD_ERRLOG     0x2c    /* FCWIN-XXXX */
#define HFC_DG_LOGERS       0x2d    /* FCWIN-0184 */
#define HFC_DGRD_HBAINFO    0x2e    /* FCWIN-0183 */
#define HFC_DGRD_LGTGT		0x30
#define HFC_DGRD_LGDEV		0x31
#define HFC_DGRD_PATHINFO	0x32
#define HFC_DGRD_PATHINFO1	0x33
#define HFC_DGRD_PATHINFO2	0x34
#define HFC_DGRD_FOINFO		0x35
#define HFC_DG_RDHG         0x36
#define HFC_DG_WRHG         0x37
    uchar    resv1                  HFC_VAL_ATTR_C;
    uchar    resv2                  HFC_VAL_ATTR_C;
    uchar    resv3                  HFC_VAL_ATTR_C;
    union {

        struct fw_trc_info trc_mode HFC_VAL_ATTR;   /* --- Set FPP Trace Mode --- */

        struct {                                    /* --- Load CH Trace Log ---- */
            struct {                                /* FPP Trace Pointer */
                ushort  sp          HFC_VAL_ATTR;
                ushort  ep          HFC_VAL_ATTR;
                uchar   ctl         HFC_VAL_ATTR_C;
                uchar   resv0       HFC_VAL_ATTR_C;
                ushort  cp          HFC_VAL_ATTR;
            }trc_ptr[4];
            struct {                                /* Frame Trace Pointer */
                ushort  sp          HFC_VAL_ATTR;
                ushort  ep          HFC_VAL_ATTR;
                uchar   ctl         HFC_VAL_ATTR_C;
                uchar   resv0       HFC_VAL_ATTR_C;
                ushort  cp          HFC_VAL_ATTR;
            }frm_trc_ptr;
            uchar   resv4[88]       HFC_VAL_ATTR_C;
        }ch_trc_log;

        struct {                                    /* --- Read Xrb/Xob --------- */
            ushort   no             HFC_VAL_ATTR;   /* read no  */
            ushort   cnt            HFC_VAL_ATTR;   /* read cnt */
            ushort   current_no     HFC_VAL_ATTR;   /* current_no */
            uchar    resv4[122]     HFC_VAL_ATTR_C;
        }xob_xrb_scmd;

        struct {                                    /* --- Read Target/Dev ------ */
            uint64_t target_id      HFC_VAL_ATTR;   /* TARGET ID */
            uint64_t lun_id         HFC_VAL_ATTR;   /* LUN ID */
            uint64_t ww_name        HFC_VAL_ATTR;   /* World Wide Port Name @dyntrk */
            uchar   resv4[104]      HFC_VAL_ATTR_C;   /* @dyntrk */
        }dev_target;

        struct {                                    /* --- Read device tree ----- */
            uchar   type            HFC_VAL_ATTR_C;   /* sub_cmd                    */
                                                    /*  HFC_DGRD_MP(mp_info)      */
                                                    /*  HFC_DGRD_ADAP(adap_info)  */
                                                    /*  HFC_DGRD_TARGET(target)   */
                                                    /*  HFC_DGRD_DEV(device)      */
            uchar   resv3[3]        HFC_VAL_ATTR_C;
            uint    entry_num       HFC_VAL_ATTR;   /*  responce entry num        */
            uchar   resv4[120]      HFC_VAL_ATTR_C;
        }dev_tree;

        struct {                                    /* --- mih log -------------- */
            uchar   log[32]         HFC_VAL_ATTR_C;   /* log infomation */
            uchar   resv4[96]       HFC_VAL_ATTR_C;
        }mih_log;

        struct {                                    /* --- Loop ----------------- */
            uchar   resv4[128]		HFC_VAL_ATTR_C;
        }loop;

        struct {                                    /* --- FW DIAG Post --------- */
            uchar   cmd             HFC_VAL_ATTR_C;   /* command */
#define POST_CMD_BOOT		0x11					/*  BOOTtest				*/
#define POST_CMD_IMEM 		0x12					/*  internal RAM test		*/
#define POST_CMD_ILOOP		0x13					/*  internal LOOP test		*/
#define POST_CMD_DMA		0x14					/*  DMA test				*/
#define POST_CMD_ELOOP		0x15					/*  external LOOPtest		*/
#define POST_CMD_LLOOP		0x16
#define POST_CMD_BOOT_MLT	0x17					/*  multi BOOT test			*/
#define POST_CMD_ILOOP_MLT	0x18					/*  multi internal LOOP test */
#define POST_CMD_ELOOP_MLT	0x19					/*  multi external LOOP test */
#define POST_CMD_LLOOP_MLT	0x1a					/*  multi WRAP test         */
            uchar   reslt           HFC_VAL_ATTR_C;   /* result this test         */
            uchar   err_code[3]     HFC_VAL_ATTR_C;   /* err_code                 */
            uchar   resv4[123]      HFC_VAL_ATTR_C;
        }post;

        struct {                                    /* --- pci ------------------ */
            uint    addr            HFC_VAL_ATTR;   /* PCI offset address */
            uchar   resv4[124]      HFC_VAL_ATTR_C;
        }pci;

        struct {                                    /* --- FW Start ------------- */
            uchar   mode            HFC_VAL_ATTR_C;                   /* mode */
#define FW_MODE_NORMAL      0x00                    /* normal               */
#define FW_MODE_DIAG        0x08                    /* diag                 */
#define FW_MODE_NAI_LOOP    0x81                    /* internal loop        */
#define FW_MODE_GAI_LOOP    0x82                    /* external loop        */
#define FW_MODE_IOS         0x83                    /* IOS mode             */
#define FW_MODE_WRAP        0x84                    /* WRAP                 */
            uchar   err_code        HFC_VAL_ATTR_C;   /* filed DIAG test */
                                                    /*   err_code is set in DA.    */
                                                    /*   (only valid in FW_MODE_NORMAL) */
#define FW_DIAG_SUCCESS     0x00                    /*  succeed DIAG test   */
#define FW_DIAG_FAILED      0x80                    /*  failed  DIAG test   */
            uchar   resv4[126]      HFC_VAL_ATTR_C;
        }fw_start;
         /* @030131 */
        struct {                                    /* --- Forced sogt LOG ------- */
            ushort  dependent_code  HFC_VAL_ATTR;   /* dependent_code */
            uchar   resv0[2]        HFC_VAL_ATTR_C;
            uchar   resv1[124]      HFC_VAL_ATTR_C;
        }forced_log;

        struct {                                    /* --- INIT MODE SET ------- */
            union {
                uint mode           HFC_VAL_ATTR;
                uchar uc_mode[4]    HFC_VAL_ATTR_C;
                uchar al_pa[4]      HFC_VAL_ATTR_C;
            }mode_alpa;
            uint    connect_type    HFC_VAL_ATTR;   /* Connection Type */
#define FW_CONTYPE_PTOP     0x00000001              /*  PtoP  */
#define FW_CONTYPE_AL       0x00000003              /*  FC-AL */
            uchar   resv0[ 4 ]      HFC_VAL_ATTR_C;
            uint64_t wwpn           HFC_VAL_ATTR;   /* World Wide Port Name @dyntrk */
            uint64_t wwnn           HFC_VAL_ATTR;   /* World Wide Node Name @dyntrk */
            uint    buf_size        HFC_VAL_ATTR;   /* Buffer Size */
            uint    xrdy_div        HFC_VAL_ATTR;   /* XRDY Divsize */
            uint    param           HFC_VAL_ATTR;   /* Parameter */
            uchar   resv1[ 88 ]     HFC_VAL_ATTR_C;
        }init_mode_set;

        struct {                                    /* --- FCP MODE SET ------- */
            uint    act_ctl         HFC_VAL_ATTR;   /* ACT-CTL */
            uint    il_ctl          HFC_VAL_ATTR;   /* IL-CTL */
            uint    seq_ctl         HFC_VAL_ATTR;   /* SEQ-CTL */
            uint    rsp_delay       HFC_VAL_ATTR;   /* RESP-DELAY */
            uchar   resv[112]       HFC_VAL_ATTR_C;
        }fcp_mode_set;

        struct {                                    /* --- pkg type --- */
            uchar   pkgtype         HFC_VAL_ATTR_C;
#define HFC_PKTYPE_FPP          1                   /* FPP          FCWIN-0179 */
#define HFC_PKTYPE_FIVE         2                   /* Five         FCWIN-0179 */
            uchar   pkgid           HFC_VAL_ATTR_C;
#define HFC_PKID_3009           0                   /* FPP                      */
#define HFC_PKID_300A           1                   /* FIVE                     */
#define HFC_PKID_300B           2                   /* FIVE                     */
#define HFC_PKID_300C           3                   /* FIVE                     */
#define HFC_PKID_300D           4                   /* FIVE                     */

            uchar   resv[126]       HFC_VAL_ATTR_C;
        }pkg_type;

        struct {                                    /* --- adapter unique_id --- */     /* FCWIN-XXXX */
            uint    uid             HFC_VAL_ATTR;
        }uni_id;

        struct {                                    /* --- log erase --- */             /* FCWIN-0184 */
            uint    log_no          HFC_VAL_ATTR;
        }log_erase;

    }uni;
    uint                length      HFC_VAL_ATTR;   /* --- output size     ----- */
    uint64_t            addr        HFC_VAL_ATTR;   /* --- output address  ----- */
};

/************************************************************************/
/* IOCTL                                                                */
/************************************************************************/
/********************************************/
/* IOCTL_HFC_SC_INQU : issue INQUIRY 2005.01.19      */
/********************************************/
struct hfc_ioctl_inquiry {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       resv1[2]        HFC_VAL_ATTR_C;   /* reserved                             */

    uchar       extended        HFC_VAL_ATTR_C;   /* TRUE / FALSE                         */
    uchar       page_code       HFC_VAL_ATTR_C;   /* page code # when extended = TRUE     */
    ushort      data_length     HFC_VAL_ATTR;   /* pointer to inquiry data length       */

    /******  8 byte boundary ********/
    uint64_t    buffer          HFC_VAL_ATTR;   /* pointer to inquiry data buffer       */

        /******  8 byte boundary ********/
    uint64_t    Port_WWN        HFC_VAL_ATTR;   /* Port_WWN                             */
    uint64_t    lun_id          HFC_VAL_ATTR;   /* Lun ID                               */

    /******  8 byte boundary ********/
    uchar       scsi_status     HFC_VAL_ATTR_C;   /* SCSI status                          */
    uchar       resid_flags     HFC_VAL_ATTR_C;
#define HFC_RESID_UNDERFLOW 0x80                  /* underflow                            */
    ushort      resid           HFC_VAL_ATTR;     /* remain byte                          */

    uchar       resv2[3]        HFC_VAL_ATTR_C;
    uchar       did_err         HFC_VAL_ATTR_C;   /* adapter status                       */
    /******  8 byte boundary ********/
    uint64_t    sense_ptr       HFC_VAL_ATTR;     /* if scsi_status<check condition>=1    */

    uchar       resv5[2]        HFC_VAL_ATTR_C;
    ushort      sense_len       HFC_VAL_ATTR;     /* if scsi_status<check condition>=1    */
};

/********************************************/
/* IOCTL_HFC_SC_CMD : issue SCSI command 2005.01.19*/
/********************************************/
struct hfc_ioctl_cdb {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
#define SCSI_READ_CDB       0x80
#define SCSI_WRITE_CDB      0x40
#define SCSI_PATH_HEALTH    0x01                /* FCLNX-0408 */

    uchar       resv1[2]        HFC_VAL_ATTR_C;   /* reserved                             */
    uchar       resv2[2]        HFC_VAL_ATTR_C;
    ushort      data_length     HFC_VAL_ATTR;   /* bytes of data to be transfered       */

    /******  8 byte boundary ********/
    uint64_t    buffer          HFC_VAL_ATTR;   /* pointer to transfer data buffer      */

        /******  8 byte boundary ********/
    uint64_t    Port_WWN        HFC_VAL_ATTR;   /* Port_WWN                             */
    uint64_t    lun_id          HFC_VAL_ATTR;   /* Lun ID                               */

    /******  8 byte boundary ********/
    uchar       tag_q           HFC_VAL_ATTR_C;   /* tag-Q type                           */
    uchar       command_length  HFC_VAL_ATTR_C;   /* length of SCSI CDB                   */
    uchar       resv3[6]        HFC_VAL_ATTR_C;

    /******  8 byte boundary ********/
    uchar       cdb[16]         HFC_VAL_ATTR_C;   /* SCSI command descriptor block        */

    uchar       scsi_status     HFC_VAL_ATTR_C;   /* SCSI status                          */
    uchar       resid_flags     HFC_VAL_ATTR_C;
#define HFC_RESID_UNDERFLOW 0x80                /* The transfer length is insufficient. */
    ushort      resid           HFC_VAL_ATTR;   /* remained byte count                  */

    uchar       resv4[3]        HFC_VAL_ATTR_C;
    uchar       did_err         HFC_VAL_ATTR_C;   /* adapter status                       */

    /******  8 byte boundary ********/
    uint64_t    sense_ptr       HFC_VAL_ATTR;   /* if scsi_status<check condition>=1    */

    uchar       resv7[2]        HFC_VAL_ATTR_C;
    ushort      sense_len       HFC_VAL_ATTR;   /* if scsi_status<check condition>=1    */
};

/********************************************/
/* IOCTL_HFC_SC_NMSRV : issue GID_FT        */
/********************************************/
struct hfc_ioctl_gidft {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       set_flags       HFC_VAL_ATTR_C;   /* set flags                            */
#define NM_LIST_SHORT   0x01
    uchar       resv1[1]        HFC_VAL_ATTR_C;   /* reserved                             */

    uchar       resv2           HFC_VAL_ATTR_C;   /* reserved                             */
    uchar       adapter_status  HFC_VAL_ATTR_C;   /* adapter status                       */
    uchar       resv3[2]        HFC_VAL_ATTR_C;   /* reserved                             */

    uchar       scsi_id_size    HFC_VAL_ATTR_C;   /* size in bytes of a SCSI ID           */
    uchar       resv4[3]        HFC_VAL_ATTR_C;   /* reserved                             */
    uint        timeout_value   HFC_VAL_ATTR;   /* timeout value for command.(sec)      */

    /******  8 byte boundary ********/
    uint        list_len        HFC_VAL_ATTR;   /* length of scsi_id_list.(byte)        */
    uint        num_ids         HFC_VAL_ATTR;   /* Number of SCSI ID in the list        */

    /******  8 byte boundary ********/
    uint64_t    scsi_id_list    HFC_VAL_ATTR;   /* SCSI ID list pointer                 */
};

/* parameter */
#define HFC_GS_INV_CODE                     0x01        /* Invalid Command Code      */
#define HFC_GS_INV_VERS                     0x02        /* Invalid Version           */
#define HFC_GS_LOG_ERR                      0x03        /* Logical Error             */
#define HFC_GS_INV_IU_SIZE                  0x04        /* Invalid IU Size           */
#define HFC_GS_BSY                          0x05        /* Logical Busy              */
#define HFC_GS_PROTO_ERR                    0x07        /* Protocol Error            */
#define HFC_GS_FAILED                       0x09        /* Unable to perform request */
#define HFC_GS_CMD_NOT_SPT                  0x0b        /* Command Not supported     */

#define HFS_GS_NO_EXP                       0x00        /* No additional explanation */
#define HFS_GS_EXP_NO_ID                    0x01        /* Port Identifier not registered       */
#define HFS_GS_EXP_NO_WWN                   0x02        /* Port Name not registered   */
#define HFS_GS_EXP_NO_NODE                  0x03        /* Node Name not registered   */
#define HFS_GS_EXP_NO_CLASS                 0x04        /* Class of Service not registered      */
#define HFS_GS_EXP_NO_IP_ADDR               0x05        /* IP address not registered  */
#define HFS_GS_EXP_NO_PA                    0x06        /* Initial Process Associator not registered */
#define HFS_GS_EXP_NO_FC4S                  0x07        /* FC-4 Types not registered  */
#define HFS_GS_EXP_NO_SYM_PORT              0x08        /* Symbolic Port Name not registered    */
#define HFS_GS_EXP_NO_SYM_NODE              0x09        /* Symbolic Node Name not registered    */
#define HFS_GS_EXP_NO_PORT_TYPE             0x0a        /* Port Type not registered   */
#define HFS_GS_EXP_NO_ACCESS                0x10        /* Access Denied              */
#define HFS_GS_EXP_INV_PORT                 0x11        /* Unacceptable Port Identifier         */
#define HFS_GS_EXP_DB_EMPTY                 0x12        /* Database empty.            */

/********************************************/
/* IOCTL_HFC_SC_GWWN : issue GID_PN         */
/********************************************/
struct hfc_ioctl_gidpn {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       resv1[2]        HFC_VAL_ATTR_C;   /* reserved                             */

    uchar       resv2           HFC_VAL_ATTR_C;   /* reserved                             */
    uchar       adapter_status  HFC_VAL_ATTR_C;   /* adapter status                       */
    uchar       resv3[2]        HFC_VAL_ATTR_C;   /* reserved                             */

    /******  8 byte boundary ********/
    uint64_t world_wide_name    HFC_VAL_ATTR;   /* World Wide Port Name                 */

    /******  8 byte boundary ********/
    uint64_t scsi_id            HFC_VAL_ATTR;   /* return SCSI ID                       */
};

/********************************************/
/* IOCTL_HFC_SC_GSID : issue GPN_ID         */
/********************************************/
struct hfc_ioctl_gpnid {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       resv1[2]        HFC_VAL_ATTR_C;   /* reserved                             */

    uchar       resv2           HFC_VAL_ATTR_C;   /* reserved                             */
    uchar       adapter_status  HFC_VAL_ATTR_C;   /* adapter status                       */
    uchar       resv3[2]        HFC_VAL_ATTR_C;   /* reserved                             */

    /******  8 byte boundary ********/
    uint64_t scsi_id            HFC_VAL_ATTR;   /* SCSI ID                              */

    /******  8 byte boundary ********/
    uint64_t world_wide_name    HFC_VAL_ATTR;   /* return World Wide Port Name          */
};

/********************************************/
/* IOCTL_HFC_SC_PAYLD : issue SCSI PAYLD    */
/********************************************/
struct hfc_ioctl_payload {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       type            HFC_VAL_ATTR_C;   /* payload type                         */
    uchar       ctl             HFC_VAL_ATTR_C;
    uchar       class           HFC_VAL_ATTR_C;
    uchar       resv0[3]        HFC_VAL_ATTR_C;

    uint64_t    scsi_id         HFC_VAL_ATTR;

    uint64_t    payld_buffer    HFC_VAL_ATTR;   /* send payload                         */
    uchar       resv1[4]        HFC_VAL_ATTR_C;
    int         payld_size      HFC_VAL_ATTR;

    uint64_t    response_buffer HFC_VAL_ATTR;   /* responce payload                     */
    uchar       resv2[4]        HFC_VAL_ATTR_C;
    int         response_size   HFC_VAL_ATTR;
};

struct PAYLD {
    uchar flags;
    uchar resv0[ 3 ];
    uchar payld_class;
    uchar resv1[ 3 ];
    uint resv2;
    ushort resv3;
    ushort payload_length;
    uchar tseq;
    uchar nfw[ 3 ];
    uint resv4[ 3 ];
    union {
        uchar rctl;
        uint d_id;
    } dst;
    union {
        uchar cs_ctl;
        uint s_id;
    } src;
    uchar type;
    uchar f_ctl[ 3 ];
    uchar seq_id;
    uchar df_ctl;
    ushort seq_cnt;
    ushort ox_id;
    ushort rx_id;
    uint paramater;
    uint resv5[ 242 ];
    uchar frame_payload[ 2048 ];
};

/********************************************/
/* IOCTL_HFC_SC_RNID : get & put RNID       */
/********************************************/
struct hfc_ioctl_rnid {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       cmd             HFC_VAL_ATTR_C;
    uchar       adapter_status  HFC_VAL_ATTR_C;

    uchar       common_node_len HFC_VAL_ATTR_C;
#define RNID_COM_NODE_LEN   16
    uchar       spcfic_node_len HFC_VAL_ATTR_C;
#define RNID_SPF_NODE_LEN   52
    uchar       resv0[2]        HFC_VAL_ATTR_C;

    /******  8 byte boundary ********/
    uint64_t    port_name       HFC_VAL_ATTR;
    uint64_t    node_name       HFC_VAL_ATTR;

    /******  8 byte boundary ********/
    uint64_t    vendor_unique[2]    HFC_VAL_ATTR;

    /******  8 byte boundary ********/
    uint        node_type       HFC_VAL_ATTR;
    uint        port_number     HFC_VAL_ATTR;

    /******  8 byte boundary ********/
    uint        num_att_nodes   HFC_VAL_ATTR;
    uchar       node_mgmt       HFC_VAL_ATTR_C;
    uchar       ip_ver          HFC_VAL_ATTR_C;
    ushort      udp_port        HFC_VAL_ATTR;

    /******  8 byte boundary ********/
    uint64_t    ip_addr[2]      HFC_VAL_ATTR;

    /******  8 byte boundary ********/
    ushort      disc_flags      HFC_VAL_ATTR;
    uchar       resv1[6]        HFC_VAL_ATTR_C;
};

/********************************************/
/* IOCTL_HFC_SC_ADPST : adapter statistics  */
/********************************************/
struct hfc_ioctl_adap_stat {
    uchar       version         HFC_VAL_ATTR_C;   /* version code                         */
    uchar       flags           HFC_VAL_ATTR_C;   /* control flags                        */
    uchar       cmd             HFC_VAL_ATTR_C;
    uchar       adapter_status  HFC_VAL_ATTR_C;
    uchar       resv[4]         HFC_VAL_ATTR_C;

    uint64_t seconds_since_last_reset   HFC_VAL_ATTR;
    uint64_t tx_frames          HFC_VAL_ATTR;
    uint64_t tx_words           HFC_VAL_ATTR;
    uint64_t rx_frames          HFC_VAL_ATTR;
    uint64_t rx_words           HFC_VAL_ATTR;
    uint64_t lip_count          HFC_VAL_ATTR;
    uint64_t nos_count          HFC_VAL_ATTR;
    uint64_t error_frames       HFC_VAL_ATTR;
    uint64_t dumped_frames      HFC_VAL_ATTR;
    uint64_t link_failure_count HFC_VAL_ATTR;
    uint64_t loss_of_sync_count HFC_VAL_ATTR;
    uint64_t loss_of_signal_count   HFC_VAL_ATTR;
    uint64_t primitive_seq_protocol_err_count   HFC_VAL_ATTR;
    uint64_t invalid_tx_word_count  HFC_VAL_ATTR;
    uint64_t invalid_crc_count  HFC_VAL_ATTR;
};


/********************************************/
/* IOCTL_HFC_SC_API : get adapter attribute */
/********************************************/
struct hfc_ioctl_api {
    uchar       sub_cmd             HFC_VAL_ATTR_C;   /* sub-command              */
#define HFC_GET_ADAPTER_ATTR        0x01            /* Adapter Attribute        */
#define HFC_GET_PORT_ATTR           0x02            /* Port Attribute           */

    uchar       valid               HFC_VAL_ATTR_C;   /* Valid bit                */
#define HFC_API_SCSI_ID_VALID       0x80            /*   vaild scsi_id          */
#define HFC_API_WWN_VALID           0x40            /*   vaild world_wide_name  */

    uchar       resv1[2]            HFC_VAL_ATTR_C;
    uint        scsi_id             HFC_VAL_ATTR;
    uint64_t    world_wide_name     HFC_VAL_ATTR;
    uchar       resv2[100]          HFC_VAL_ATTR_C;
    uint        length              HFC_VAL_ATTR;
    uint64_t    addr                HFC_VAL_ATTR;
};

/************************************/
/*  report adapter attribute        */
/*   sub_cmd=HFC_GET_ADAPTER_ATTR   */
/************************************/
struct hfc_ioctl_adap_attr {
#define HFC_MANUFACTURE_SIZE        32
#define HFC_SERIALNUMBER_SIZE       32
#define HFC_NODE_SYMBOL_SIZE        128
#define HFC_HW_VER_SIZE             128
#define HFC_DD_VER_SIZE             128
#define HFC_ROM_VER_SIZE            128
#define HFC_FW_VER_SIZE             128

    uchar       manufacturer[HFC_MANUFACTURE_SIZE] ;
    uchar       serialnumber[HFC_SERIALNUMBER_SIZE] ;
    uint64_t    node_wwn ;
    uchar       node_symbolic_name[HFC_NODE_SYMBOL_SIZE] ;
    uchar       hardware_version[HFC_HW_VER_SIZE] ;
    uchar       driver_version[HFC_DD_VER_SIZE] ;
    uchar       option_rom_version[HFC_ROM_VER_SIZE] ;
    uchar       firmware_version[HFC_FW_VER_SIZE] ;
    uint        vendor_specific_id ;
    uint        number_of_ports ;
#define HFC_NUM_OF_PORTS_1          1
};

/************************************/
/*  report port attribute           */
/*   sub_cmd=HFC_GET_PORT_ATTR      */
/************************************/
struct hfc_ioctl_port_attr {
    uchar       flags ;
#define HFC_GET_ADAP_PORT           0x01
#define HFC_GET_DISC_PORT           0x02

    uchar       resv0[7];
    uint64_t    node_wwn ;
    uint64_t    port_wwn ;
    uint        port_fcid ;

    uint        port_type ;
#define HFC_PORTTYPE_UNKNOWN        1
#define HFC_PORTTYPE_OTHER          2
#define HFC_PORTTYPE_NOTPRESENT     3
#define HFC_PORTTYPE_NPORT          5
#define HFC_PORTTYPE_NLPORT         6
#define HFC_PORTTYPE_FLPORT         7
#define HFC_PORTTYPE_FPORT          8
#define HFC_PORTTYPE_LPORT          20
#define HFC_PORTTYPE_PTP            21

    uint        port_state ;
#define HFC_PORTSTATE_UNKNOWN       1
#define HFC_PORTSTATE_ONLINE        2
#define HFC_PORTSTATE_OFFLINE       3
#define HFC_PORTSTATE_BYPASSED      4
#define HFC_PORTSTATE_DIAGNOSTICS   5
#define HFC_PORTSTATE_LINKDOWN      6
#define HFC_PORTSTATE_ERROR         7
#define HFC_PORTSTATE_LOOPBACK      8

    uint        port_support_class_of_service ;
#define HFC_SUPPORT_CLASS           0x00000008

    char        port_support_fc4_types[32] ;
    char        port_active_fc4_types[32] ;

#define HFC_NODE_SYMBOL_SIZE        128
    char        port_symbol_name[HFC_NODE_SYMBOL_SIZE] ;

    uint        port_supported_speed ;
#define HFC_PORTSPEED_UNKNOWN       0
#define HFC_PORTSPEED_1GBIT         1
#define HFC_PORTSPEED_2GBIT         2
#define HFC_PORTSPEED_10GBIT        4
#define HFC_PORTSPEED_4GBIT         8

    uint        port_speed ;

    uint        port_max_frame_size ;
#define HFC_PORT_MAX_FRAME          2048

    uint        num_of_disc_port ;

#define HFC_MAX_DISC_PORT           256
    uint64_t    disc_wwn[HFC_MAX_DISC_PORT] ;
};

struct hfc_ioctl_spt {
    uchar   support_flag[0x10]      HFC_VAL_ATTR_C;
};

/************************************************/
/* IOCTL_HFC_SC_TGTMAP : for targetMapping      2005.01.19*/
/************************************************/

typedef struct hfc_scsiid {
  uchar         rsv0[3]             HFC_VAL_ATTR_C;
  uchar         target_id           HFC_VAL_ATTR_C;
  uint          target_valid        HFC_VAL_ATTR;
#define  HFC_TGTWWN_VALID               0x00000080
#define  HFC_SCSIID_VALID               0x00000040
} HFC_SCSIID;

typedef struct hfc_fcpid {
  uint64_t      node_wwn            HFC_VAL_ATTR;
  uint64_t      port_wwn            HFC_VAL_ATTR;
  uint          scsi_id             HFC_VAL_ATTR;
  uchar         rsv2[4]             HFC_VAL_ATTR_C;   /* 2005.02.23 [3]->[4] */
} HFC_FCPID;

typedef struct hfc_tgtmap_entry {
  HFC_SCSIID    scsiid;
  HFC_FCPID     fcpid;
} HFC_TGTMAP_ENTRY;

typedef struct hfc_tgtmap_hedder {
  uchar         version             HFC_VAL_ATTR_C;   /* version code                         */
  uchar         flags               HFC_VAL_ATTR_C;   /* control flags                        */
  uchar         resv1[6]            HFC_VAL_ATTR_C;
  uint          number_of_entries   HFC_VAL_ATTR;
  uint          number_of_target    HFC_VAL_ATTR;
  uchar         resv2[16]           HFC_VAL_ATTR_C;
} HFC_TGTMAP_HEDDER;

struct hfc_ioctl_tgt_map {
  HFC_TGTMAP_HEDDER     hedder[1];
  HFC_TGTMAP_ENTRY      entry[1];
};

/************************************************/
/* IOCTL_HFC_SC_PBIND : for fcpBinding2005.02.08*/
/************************************************/
typedef struct hfc_fcpbind_entry {
  uint         fcp_binding_type     HFC_VAL_ATTR;
  uchar        rsv0[3]              HFC_VAL_ATTR_C;
  uchar        target_id            HFC_VAL_ATTR_C;
  uint64_t     data                 HFC_VAL_ATTR;
  uint         N_port_id            HFC_VAL_ATTR;
  uchar        rsv1[4]              HFC_VAL_ATTR_C;
} HFC_FCPBIND_ENTRY;

typedef struct hfc_fcpbind_hedder {
  uchar        version              HFC_VAL_ATTR_C;   /* version code                         */
  uchar        flags                HFC_VAL_ATTR_C;   /* control flags                        */
  uchar        resv1[6]             HFC_VAL_ATTR_C;
  uint         number_of_entries    HFC_VAL_ATTR;
  uint         number_of_target     HFC_VAL_ATTR;
  uchar        resv2[16]            HFC_VAL_ATTR_C;
} HFC_FCPBIND_HEDDER;

struct hfc_ioctl_fcp_binding {
  HFC_FCPBIND_HEDDER    hedder[1];
  HFC_FCPBIND_ENTRY     entry[1];
};

/************************************************/
/* IOCTL_HFC_SC_PRINFO : for proc_info2005.01.28*/
/************************************************/
struct hfc_ioctl_proc_info {
  uchar     version             HFC_VAL_ATTR_C;   /* version code           */
  uchar     flags               HFC_VAL_ATTR_C;   /* control flags          */
  uchar     rsv0[6]             HFC_VAL_ATTR_C;   /*                        */
                                                  /*                        */
  int       dev_major           HFC_VAL_ATTR;     /* Major_number           */
  int       dev_minor           HFC_VAL_ATTR;     /* Minor_number           */
  uchar     instance            HFC_VAL_ATTR_C;   /* instance               */
  uchar     rsv1[1]             HFC_VAL_ATTR_C;   /*                        */
  ushort    host_no             HFC_VAL_ATTR;     /* Host#                  */
  uint      unique_id           HFC_VAL_ATTR;     /* Unique_id              */
  uchar     rsv2[4]             HFC_VAL_ATTR_C;   /*                        */
  ushort    vender_id           HFC_VAL_ATTR;     /* Vender ID              */
  ushort    device_id           HFC_VAL_ATTR;     /* Device ID              */
                                                  /*                        */
  uint64_t  ww_name             HFC_VAL_ATTR;     /* Port name              */
  uint64_t  node_name           HFC_VAL_ATTR;     /* Node name              */
  uint64_t  scsi_id             HFC_VAL_ATTR;     /* DID                    */
  uchar     rsv3[8]             HFC_VAL_ATTR_C;   /*                        */
                                                  /*                        */
  uchar     adap_id[16]         HFC_VAL_ATTR_C;   /* adapter ID             */
                                                  /*                        */
  uchar     model_name[16];    				      /* Model Name             */ //FCLNX-0148
  uchar     driver_ver[16];    					  /* driver_ver             */ //FCLNX-0148
  uint      firmware_ver;      					  /* firmware_ver           */ //FCLNX-0148
  uchar     rsv6[12]			HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0404 */
  uchar		parts_number[16]	HFC_VAL_ATTR_C;   /* parts number           */ /* FCLNX-0404 */
  uchar		pkgtype				HFC_VAL_ATTR_C;   /* Package Type           */ /* FCLNX-0404 */
  uchar		pkgcode				HFC_VAL_ATTR_C;   /* Package ID             */ /* FCLNX-0404 */
  uchar		ec_level			HFC_VAL_ATTR_C;   /* ec level               */ /* FCLNX-0404 */
  uchar		bus_dev_func[3]     HFC_VAL_ATTR_C;   /* location(Bus Dev Func) */ /* FCLNX-0404 */
  uchar		port_no				HFC_VAL_ATTR_C;   /* port number            */ /* FCLNX-0404 */
  uchar		mlpf_mode			HFC_VAL_ATTR_C;	  /* MLPF mode              */ /* FCLNX-0454 */
  uchar		port_status			HFC_VAL_ATTR_C;	  /* Link Status	    	*/ /* FCLNX-0488 */
#define HFC_LINKUP				0x00				/* Link is in link-up status */
#define	HFC_LINKDOWN			0x02				/* Link is in link-down status */
#define HFC_WAITLINKUP			0x01				/*Waiting status change from LINK_Down to LINK_Up*/	/* FCLNX-0514 */
// #define HFC_HWISOLATE_E			0x84				/* Adapter is isolated */
// #define HFC_HWISOLATE_C			0x83				/* Forced adapter into isolated state */
#define HFC_ISOLATE_E			0x04				/* Adapter port is isolated */
#define HFC_ISOLATE_C			0x03				/* Forced adapter port into isolated state */
#define HFC_SFPFAIL				0x05				/* Transfer Error */	/* FCLNX-0514 */
#define HFC_SFPNOTSUPPORT		0x06				/* Not Supported */		/* FCLNX-0514 */
#define	HFC_SFPDOWN				0x07 				/* SFP Down */			/* FCLNX-0514 */
#define HFC_CHKSTP_E			0x08				/* Check Stop */
#define HFC_CHKSTP_C			0x09				/* Check Stop (C) */
#define HFC_UNKNOWN_STATUS		0xff				/* Unknown Status */	/* FCLNX-0514 */
  uchar		highconf_opt		HFC_VAL_ATTR_C;   /* Enable|Disable to Blockade Operation */ /* FCLNX-0488 */
  uchar		abort_t_restrain	HFC_VAL_ATTR_C;	  /* Restrain to AbortT.S */	/* FCLNX-0542 */  
  uchar		rsv7[5]				HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0542 */
  uchar		opt_vendor_name[32] HFC_VAL_ATTR_C;   /* Opt mod vendor name    */ /* FCLNX-0404 */
  uchar		opt_parts_number[32] HFC_VAL_ATTR_C;  /* Opt mod parts num    */ /* FCLNX-0404 */
  uchar		opt_serial_number[32]HFC_VAL_ATTR_C;  /* Opt mod serial num   */ /* FCLNX-0404 */
  uchar     rsv8[336]			HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0404 */
  uchar     connection_type     HFC_VAL_ATTR_C;   /*                        */
#define HFC_CON_TYP_PtoPF 0x02                  /* Point to Point(fabric) */
#define HFC_CON_TYP_PtoP  0x03                  /* Point to Point         */
#define HFC_CON_TYP_FcAlF 0x04                  /* FC-AL(fabric)          */
#define HFC_CON_TYP_FcAl  0x05                  /* FC-AL                  */
#define HFC_CON_TYP_NONE  0x00                  /* UnKnown                */
  uchar     rsv4[3]             HFC_VAL_ATTR_C;   /*                        */
  uint      max_data_rate       HFC_VAL_ATTR;     /* ex. 100->1Gbps         */
                                                  /*                        */
  uchar		login_delay			HFC_VAL_ATTR_C;   /* LOGIN Delay Time       */ /* FCLNX-0404 */
  uchar		spinup_delay		HFC_VAL_ATTR_C;   /* Spinup Delay           */ /* FCLNX-0404 */
  uchar		automap				HFC_VAL_ATTR_C;   /* Automap                */ /* FCLNX-0404 */
  uchar		pref_alpa			HFC_VAL_ATTR_C;   /* Preferred AL-PA Number */ /* FCLNX-0404 */
  uchar		rsv9[12]			HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0404 */
  ushort	xob_max				HFC_VAL_ATTR;     /* Max xob number         */ /* FCLNX-0404 */
  ushort	xrb_max				HFC_VAL_ATTR;     /* Max xrb number         */ /* FCLNX-0404 */
  ushort	slog_max			HFC_VAL_ATTR;     /* Max soft log number    */ /* FCLNX-0404 */
  uchar		rsv10[10]			HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0404 */
  uint		dma_max				HFC_VAL_ATTR;     /* Max DMA Size			  */ /* FCLNX-0404 */
  uint		queue_depth			HFC_VAL_ATTR;     /* Queue depth            */ /* FCLNX-0404 */
  uint		linkup_tmo			HFC_VAL_ATTR;     /* Link Down Time         */ /* FCLNX-0404 */
  uint		scsi_reset_delay	HFC_VAL_ATTR;     /* Reset Delay Time       */ /* FCLNX-0404 */
  uint		target_reset_tmo	HFC_VAL_ATTR;     /* Reset Timeout          */ /* FCLNX-0404 */
  uint		abort_tmo			HFC_VAL_ATTR;     /* Abort timeout          */ /* FCLNX-0404 */
  uint		max_target			HFC_VAL_ATTR;     /* Max target number      */ /* FCLNX-0404 */
  uint		trc_max				HFC_VAL_ATTR;     /* Max trace number       */ /* FCLNX-0404 */
  uchar		rsv11[16]			HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0404 */
  int		max_mck_cnt			HFC_VAL_ATTR;     /* MCK Retry Count        */ /* FCLNX-0404 */
  int		wmsg				HFC_VAL_ATTR;     /* Enable Message         */ /* FCLNX-0404 */
  int		linkup2_tmo			HFC_VAL_ATTR;     /* Link Down Time (MCK)   */ /* FCLNX-0404 */
  int		pkt_num				HFC_VAL_ATTR;     /* Max pkt number         */ /* FCLNX-0404 */
  int		can_queue			HFC_VAL_ATTR;     /* Max can queue          */ /* FCLNX-0404 */
  int		sg_tblsize			HFC_VAL_ATTR;     /* Max sg tablesize       */ /* FCLNX-0404 */
  int		cmnd_num			HFC_VAL_ATTR;     /* Max cmnd number        */ /* FCLNX-0404 */
  int		minus_tout			HFC_VAL_ATTR;     /* Minus timeout          */ /* FCLNX-0404 */
  int		scsi_allowed		HFC_VAL_ATTR;     /* scsi_cmnd->allowed     */ /* FCLNX-0404 */
  int		cmd_per_lun			HFC_VAL_ATTR;     /* Max cmd per lun        */ /* FCLNX-0404 */
  int		max_sectors			HFC_VAL_ATTR;     /* Max sectors            */ /* FCLNX-0404 */
  int		scsi_timeout_fail	HFC_VAL_ATTR;     /* scsi_timeout count     */ /* FCLNX-0404 */
  uint		tmt_delay			HFC_VAL_ATTR;								   /* FCLNX-0542 */
  uint		lun_reset_delay		HFC_VAL_ATTR;	  /* LUN Reset Delay Time	*/ /* FCLNX-0542 */ /* FCLNX-GPL-038 */
  uchar		target_reset_mode	HFC_VAL_ATTR_C;	  /* Target Reset Mode 		*/ /* FCLNX-0660 */
  uchar     rsv5[287]           HFC_VAL_ATTR_C;   /*                        */ /* FCLNX-0542 */ /* FCLNX-GPL-038 */
};

/************************************************/
/* IOCTL_HFC_SC_FC4STAT : for hbaapi            */
/************************************************/
struct hfc_ioctl_fc4stat {
  uchar     version             HFC_VAL_ATTR_C; /* structure vertion code */ /* FCLNX-0404 */
  uchar     flags               HFC_VAL_ATTR_C; /* control flags("0")     */ /* FCLNX-0404 */
  uchar     rsv0[6]             HFC_VAL_ATTR_C; /* reserved ("0")         */ /* FCLNX-0404 */
  uint64_t	inputrequests		HFC_VAL_ATTR;   /* SCSI cmd cnt(read)     */ /* FCLNX-0404 */
  uint64_t	outputrequests		HFC_VAL_ATTR;   /* SCSI cmd cnt(write)    */ /* FCLNX-0404 */
  uint64_t	controlrequests		HFC_VAL_ATTR;   /* SCSI cmd cnt(not move) */ /* FCLNX-0404 */
  uint64_t	inputmegabytes		HFC_VAL_ATTR;   /* num of Mbytes of read  */ /* FCLNX-0404 */
  uint64_t	outputmegabytes		HFC_VAL_ATTR;   /* num of Mbytes of write */ /* FCLNX-0404 */
};

/************************************************/
/* IOCTL_HFC_SC_APENABLE/IOCTL_HFC_SC_APDISABLE */
/* /IOCTL_HFC_SC_SCSISCAN            2006.06.09 */
/************************************************/
struct hfc_ioctl_adp_enable {
  uchar     version             HFC_VAL_ATTR_C;   /* structure vertion code */
  uchar     flags               HFC_VAL_ATTR_C;   /* control flags("0")     */
  uchar     rsv0[6]             HFC_VAL_ATTR_C;   /* reserved ("0")         */
};

/************************************************/
/* IOCTL_HFC_READ_APPARAM 						*/
/*									 2008.01.31 */
/************************************************/
struct hfc_ioctl_read_apparam {					/* FCLNX-0514 */
	uchar	rsv[128]			HFC_VAL_ATTR_C;	
};



/********************************************/
/* IOCTL_HFC_MP_TGTMAP						*/
/********************************************/
typedef struct mp_target_entry {
  uint64_t	nodename			HFC_VAL_ATTR;	/* target WWNN				*/
  uint64_t	portname			HFC_VAL_ATTR;	/* target WWPN				*/
  uchar		flags				HFC_VAL_ATTR_C;	/* target flags				*/
#define HFC_MP_WWN_VALID	0
#define HFC_MP_LINKUP		1
#define HFC_MP_TGT_GHOST	7					/* ghost target only FC-GW  */
  uchar		attribute			HFC_VAL_ATTR_C;	/* target path attribute	*/
  uchar		groupid				HFC_VAL_ATTR_C;	/* group id				  	*/
  uchar		targetid			HFC_VAL_ATTR_C;	/* target id			 	*/
  uchar		pathid				HFC_VAL_ATTR_C;	/* target path id			*/
  uchar		instance			HFC_VAL_ATTR_C;	/* instance					*/
  uchar		rsv[2]				HFC_VAL_ATTR_C;	/*						  	*/
} MP_TARGET_ENTRY;

typedef struct mp_target_header {
  uint		entry_count			HFC_VAL_ATTR;	/* entry count				*/
  uint		target_count		HFC_VAL_ATTR;	/* target count 			*/
} MP_TARGET_HEADER;

struct hfc_mp_target {
  MP_TARGET_HEADER	header[1];					/* target header			*/
  MP_TARGET_ENTRY	entry[1];					/* target entry				*/
};


/********************************************/
/* IOCTL_HFC_HBA_ISOLATION					*/	/* FCLNX_GPL-105 */
/********************************************/
typedef struct hfc_isol_info{  /* FCLNX-0454*/
  uchar		version 			HFC_VAL_ATTR_C; /* versioncode */
  uchar		set_opr 			HFC_VAL_ATTR_C; /* Operation No.						*/
#define HFC_READ_ISOLPARAM	0					/* show the error count and adapter status */
#define HFC_FORCE_ISOLATE	1					/* Isolate the adapter forcibly. 					 */
#define HFC_FORCE_CHKSTOP	2					/* Force Check Stop				 					 */
#define HFC_RECOV_ISOLATE	3					/* Recover of Isolate status 						*/
#define HFC_STOP_ISOLATE	4					/* Stop of hba Isolate facility 					 *//* FCLNX-GPL-349 */
#define HFC_START_ISOLATE	5					/* Sart of hba Isolate facility 					 *//* FCLNX-GPL-349 */
  uchar		isol_type			HFC_VAL_ATTR_C; /* Type to Isolate adapter or Isolate adapter port		*/
  uchar		resv1[13]			HFC_VAL_ATTR_C;	 /* FCLNX-0628 */
  short		ld_err_intvl		HFC_VAL_ATTR;	/* Monitaring time for Link-Down Error					*/
  short		ld_err_limit_l		HFC_VAL_ATTR;	/* Limit to Isolate for Long Link-Down Error	*/
  short		ld_err_count_l		HFC_VAL_ATTR;	/* Count to Isolate for Long Link-Down Error	*/
  short		ld_err_limit_s		HFC_VAL_ATTR;	/* Limit to Isolate for Short Link-Down Error	*/
  short		ld_err_count_s		HFC_VAL_ATTR;	/* Count to Isolate for Short Link-Down Error	*/
  short		if_err_intvl		HFC_VAL_ATTR;	/* Monitaring time for FC Interface Error				*/
  short		if_err_limit		HFC_VAL_ATTR;	/* Limit to Isolate for FC Interface Error		*/
  short   	if_err_count 		HFC_VAL_ATTR;   /* Count to Isolate for FC Interface Error	   */
  short		to_err_intvl		HFC_VAL_ATTR;	/* Monitaring time for SCSI Time-Out Error				*/
  short		to_err_limit		HFC_VAL_ATTR;	/* Limit to Isolate for SCSI Time-Out Error 	*/
  short		to_err_count		HFC_VAL_ATTR;	/* Count to Isolate for SCSI Time-Out Error 	*/
  short		rt_err_enable		HFC_VAL_ATTR;	 /* Limit to Isolate for Reset Error					 */
  short		rt_err_count		HFC_VAL_ATTR;	/* Count to Isolate for Reset Error 					*/
  uchar		resv2[35]			HFC_VAL_ATTR_C;	/* FCLNX-0628 */
  uchar		immdt_cmd			HFC_VAL_ATTR_C;	/* FCLNX-GPL-349 */
  uchar		force_recv			HFC_VAL_ATTR_C;	/* FCLNX-GPL-349 */
  uchar		err_is_func			HFC_VAL_ATTR_C;	/* FCLNX-GPL-349 */
  uchar		err_is_fw_spt		HFC_VAL_ATTR_C;	/* FCLNX-GPL-349 */
  uchar		err_is_hvm_spt		HFC_VAL_ATTR_C;	/* FCLNX-GPL-349 */
  short		init_retry			HFC_VAL_ATTR;	/* Numberof Retry for Link Initialize */
  short		login_retry 		HFC_VAL_ATTR;	/* Numberof Retry for Login and Pdisc */
  short		els_retry			HFC_VAL_ATTR;	/* Numberof Retry for ELS */		
  short		to_reset_retry		HFC_VAL_ATTR;	/* Number of Retry for LOGIN for After SCSI T.O */
  short		scsi_to_retry		HFC_VAL_ATTR;	/* Number of Retry for SCSI Command */		 
  uchar		resv3[19]			HFC_VAL_ATTR_C;	 /* FCLNX-0628 */
  uchar		errcode				HFC_VAL_ATTR_C;
#define HFC_ISOL_NORMAL			0				/* Normal End */
#define HFC_ISOL_NOTSUPPORT		1				/* Isolate Not Support */
#define HFC_ISOL_PARMARR		2				/* Parameter Error */
  short		retry_cnt[1024] 	HFC_VAL_ATTR;	/* Threshhold to Change Path	*/ /* HFC-PCM	*/
}HFC_ISOL_INFO;


//#define MAX_FRAME_CNT       4                   /* FCLNX-0334 *//* @MLPF */
#define MAX_FRAME_CNT   (ap->lparmode.frame_cnt)                /* FCLNX-0375 */
//#define MAX_FRAME_CNT   ( ( ap->mlpf_mode & HFC_MMODE_MLPF ) ? 3 : 4)
#define MAX_MAX_FRAME_CNT     4

/* 1.92 */
typedef struct {
#ifdef __WIN
    uint64_t            performance_counter;
    uint64_t            performance_frequency;
    uint64_t            current_time;
    uchar               resv[40];
#define HFC_TRC_HEAD_CNT          24
#define HFC_TRC_ID_CNT            64
#else
    uchar               resv[64];
#define HFC_TRC_HEAD_CNT          24
#define HFC_TRC_ID_CNT            64
#endif
    /* trace */
    uchar               trace_head[HFC_TRC_HEAD_CNT][32] ;
    uchar               trace_id[HFC_TRC_ID_CNT][2] ;
    /* struct end                           offset 0x0400 */
}Typ_dderrlog ;

/* errlog (in ioctl) */
#define HFC_MAX_ERRLOG_CAP  1024
#define HFC_MAX_ERRLOG_CNT  16
struct hfc_ioctl_errlog {
    uchar               logmap[2];
    uchar               resv[14];

    struct {
        uchar           logdata[HFC_MAX_ERRLOG_CAP];
    }num[HFC_MAX_ERRLOG_CNT];
};

struct hfc_hba_info {
    struct {
        uchar topology;
#define HFC_TPG_P2P     1       /* Point to Point */
#define HFC_TPG_P2P_SW  2       /* Point to Point (Fublic) */
#define HFC_TPG_FCAL    3       /* FC-AL */
#define HFC_TPG_FCAL_SW 4       /* FC-AL (Fublic) */

        uchar linkspeed;        /* 1/2/4/10 Gbps */
        uchar rsv1[2];
        uint  rsv[15];
    }curr_value;

    struct {
        uchar topology;
        uchar linkspeed;
        uchar pref_alpa;
        uchar enable_tgtrst;
        uchar rsv1[12];
        uint  linkup_tmo;
        uint  scsi_reset_delay;
        uint  max_mck_err_cnt;
        uint  rsv2[1];
        uint  rsv3[8];
    }set;
};
/*-- Diag Sub Command ---*/
struct diag_cntl {
    uchar   sub_command ;                       /*-- see struct diag_ioctl ---*/
    uchar   support_pk ;                        /*-- see struct diag_ioctl ---*/
#define HFC_DIAG_FPP            0x01
#define HFC_DIAG_FIVE           0x02
    uint    flags_fpp ;
    uint    flags_five ;
#define HFC_DIAG_NORMAL_MODE    0x80000000      /* Normal       */
#define HFC_DIAG_DIAG_MODE      0x40000000      /* DIAG         */
#define HFC_DIAG_LOOP_MODE      0x20000000      /* LOOP         */
#define HFC_DIAG_IOS_MODE       0x10000000      /* IOS          */
#define HFC_DIAG_ARG_RESP       0x00008000      /* diag_ioctl resp */
    int     (*cmd_func)(void *, struct diag_ioctl*) ;
};
typedef struct diag_cntl Typ_diag_cntl ;

#endif /* _H_HFCDDIOC */
